<template>
  <el-col :xs="24" :sm="24" :lg="8" style="margin-bottom: 1%">
    <el-card v-if="parameters" id="tour-algorithm-component">
      <el-row style="margin-bottom: 8px">
        <el-select
          v-if="placementTypes"
          style="width: 100%"
          size="small"
          placeholder="Алгоритм"
          clearable
          v-model="parameters.placement"
        >
          <el-option
            :value="type"
            :key="type"
            v-for="type in placementTypes"
            :label="getPlacementTypeLabel(type)"
            :disabled="isDisabled(type)"
          />
        </el-select>
      </el-row>
      <el-row>
        <el-select
          :style="{ width: '100%', visibility: isShowAudiencesSelection }"
          size="small"
          placeholder="Аудитория"
          clearable
          v-model="parameters.audience"
          value-key="key"
        >
          <el-option
            v-for="audience in audiences"
            :label="`${audience.name} [${getFormattedDate(audience)}]`"
            :key="audience.key"
            :value="audience"
          >
            <span class="id">{{ getFormattedDate(audience) }}</span>
            <span class="name">{{ audience.name }}</span>
          </el-option>
        </el-select>
      </el-row>
    </el-card>
  </el-col>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { AxiosInstance } from "@/modules/AxiosInstance";
import { MediaPlan } from "@/interfaces/MediaPlan";
import { MediaPlanParametersPlacementType } from "@/interfaces/parameters/MediaPlanParametersPlacementType";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";
import { TvrParam } from "@/interfaces/parameters/TvrParam";
import ComponentMixin from "@/components/common/ComponentMixin";

/**
 * Компонент выбора алгоритма автоматического размещения медиаплана.
 *
 * @property {string}       visibility  свойство отображения формы выбора аудитории.
 * @property {MediaPlan}    mediaPlan   медиаплан.
 */
@Component
export default class PlacementTypeComponent extends Mixins(ComponentMixin) {
  private mediaPlan: MediaPlan | null = null;
  private parameters: MediaPlanParameters | null = null;

  private placementTypes: MediaPlanParametersPlacementType | null = null;

  private audiences: TvrParam[] = [];

  private readonly months = [
    "январь",
    "февраль",
    "март",
    "апрель",
    "май",
    "июнь",
    "июль",
    "август",
    "сентябрь",
    "октябрь",
    "ноябрь",
    "декабрь",
  ];
  /**
   * Метод срабатывает после создания компонента.
   */
  protected created(): void {
    // Подписываемся на событие получения информации о медиаплане
    this.subscribe("media-plan-response", this.onMediaPlanResponse);

    // Подписываемся на событие получения параметров автоматической расстановки медиаплана
    this.subscribe(
      "media-plan-parameters-response",
      this.onMediaPlanParametersResponse
    );

    // Вызываем метод запроса списка типов размещения медиаплана
    this.getPlacementTypes();
  }

  /**
   * Метод срабатывает после получения информации о медиаплане.
   *
   * @param mediaPlan {MediaPlan} меидаплан.
   */
  private onMediaPlanResponse(mediaPlan: MediaPlan): void {
    // Присваиваем полученный медиаплан к свойсву компонента
    this.mediaPlan = mediaPlan;
    // Вызываем метод получения списка аудиторий
    this.getAudiences();
  }

  /**
   * Метод срабатывает после получения параметров автоматического размещения медиаплана.
   *
   * @param {MediaPlanParameters} parameters Параметры автоматического размещения медиаплана.
   */
  private onMediaPlanParametersResponse(parameters: MediaPlanParameters): void {
    // Присваиваем полученные параметры медиаплана к свойству компонента
    this.parameters = parameters;
  }

  /**
   * Метод запроса списка аудиторий, подходящих текущему медиаплану. Метод вызывается сразу
   * после получения информации о медиаплане.
   */
  @AsyncRequestCatchException
  private async getAudiences(): Promise<void> {
    // Отправляем запрос и получаем ответ
    const response = await AxiosInstance.get(
      "media-plan-parameters/get-audiences",
      { params: { mediaPlanID: this.mediaPlan?.id } }
    );
    if (response.data && response.data instanceof Array) {
      this.audiences = response.data.map((audience) => new TvrParam(audience));
    }
  }

  /**
   * Метод запроса списка типов размещения медиаплана. Метод вызывается сразу после создания
   * компонента.
   */
  @AsyncRequestCatchException
  private async getPlacementTypes(): Promise<void> {
    // Запрос типов размещения медиаплана
    const response = await AxiosInstance.get(
      "media-plan-parameters/get-placement-types"
    );
    // Сохраняем типы размещения в свойство компонента
    this.placementTypes = response.data as MediaPlanParametersPlacementType;
  }

  /**
   * Метод определения названия типа размещения для пользователя.
   *
   * @param placementType {MediaPlanParametersPlacementType} тип размещения.
   *
   * @return {string} название типа размещения для пользователя.
   */
  private getPlacementTypeLabel(placementType: string): string {
    switch (placementType) {
      case MediaPlanParametersPlacementType.AFFINITIES:
        return "По аффинити";
      case MediaPlanParametersPlacementType.EQUAL_DISTRIBUTION:
        return "Равномерно";
      default:
        throw new Error("Не удалось определить тип размещения.");
    }
  }

  /**
   * Метод определения возможности выбора алгоритма расстановки по аффинитивности,
   * которая опирается на наличие целевой аудитории.
   *
   * @param {MediaPlanParametersPlacementType} type тип алгоритма размещения.
   *
   * @return {boolean} признак возможности выбора.
   */
  private isDisabled(type: MediaPlanParametersPlacementType): boolean {
    return (
      type == MediaPlanParametersPlacementType.AFFINITIES &&
      this.audiences.length == 0
    );
  }

  /**
   * Метод определения значения свойства отображения поля выбора целевой аудитории.
   *
   * @return {string} згачения сойства отображения поля выбора целевой аудитории.
   */
  private get isShowAudiencesSelection(): string {
    switch (this.parameters?.placement) {
      case MediaPlanParametersPlacementType.EQUAL_DISTRIBUTION:
        return "hidden";
      case MediaPlanParametersPlacementType.AFFINITIES:
        return "visible";
      default:
        return "hidden";
    }
  }

  /**
   * Метод форматирования даты в читаемый вид.
   *
   * @param audience [TvrParam] аудитория, дату которой нужно форматировать.
   * @private
   *
   * @return [string] строковое представление даты.
   */
  private getFormattedDate(audience: TvrParam): string {
    if (!audience.date) return "N/A";
    return `${audience.date.getFullYear()} ${
      this.months[audience.date.getMonth()]
    }`;
  }
}
</script>

<style lang="scss" scoped>
.el-card {
  height: 100%;
}
</style>
